Attribute VB_Name = "Conversioni"
'    Date: september 2003

'This Visual Basic Base64 encode/decode routine module is
'provided as an attachment to "CODiCE iNVERSO", an e-zine
'text about digital cryptography, published on Ondaquadra
'#10 (www.ondaquadra.org) by Zer0 (Massimo De Lirio,
'Italy). The code is "as is", and has not been proved to
'be correct, bug-free or even not potentially dangerous.
'You can distribute it or modify without any limitation
'(I'll be glad to you if you don't remove this intro,
'though...), nor warranty.
'It is not intended to be a definitive program, so please
'don't report me any bug or error you find in the code: I
'will not correct it, these are only sample routines
'intended to demonstrate the basics of a base64 routine
'programming in VB.
'If you have any question about, I recommend you to give
'a look at CODiCE iNVERSO (a quite long text, it starts on
'Ondaquadra #03, it's in Italian, though!), you can also
'find in Ondaquadra #10 my e-mail address and my PGP
'public keys.

'KEY 1: RSA 2046/ IDEA 128
'    Key ID: 0xA711DDC9
'    Key fingerprint: 1693 8400 7E5E F1C8  F34E 9970 3892 BD70
'    Created on: 02/06/01 (never expires)

'KEY 2: DH 4095/ DSA 1024/ IDEA 128
'    Key ID: 0x01965550
'    Key fingerprint: 989B 2124 8577 E5B9 3BFE  9B2D B22E 46BB 0196 5550
'    Created on: 19/08/01 (never expires)
    
Option Explicit
Option Base 0


Public Function Base64Encode(ByVal ASCIItext As String, ByRef EncodedBuffer As String) As Long
    Base64Encode = 0
    'DICHIARAZIONI
    Dim ConvertionTable64 As String * 64
    Dim i As Long
    Dim a As Long
    Dim lenght As Long
    Dim Buffer As Long
    Dim Pos As Long
    Dim char As Byte
    'INIZIALIZZAZIONE
    ConvertionTable64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
    i = Len(ASCIItext)
    If i = 0 Then
        Base64Encode = -6
        Exit Function
    End If
    Buffer = 0
    a = 0
    Pos = 4
    lenght = i \ 3
    If i Mod 3 <> 0 Then lenght = lenght + 1
    EncodedBuffer = Space(lenght * 4)
    lenght = i
    i = 0
    'CODIFICA
    Do
        i = i + 1
        'SHIFTA E RIEMPE IL BUFFER
        Buffer = Buffer * 256
        Buffer = Buffer Or Asc(Mid(ASCIItext, i, 1))
        a = a + 1
        If a = 3 Then
            'BUFFER FULL
            For a = 0 To 3
                'SCRITTURA DATI
                char = Buffer And 63
                char = char + 1
                Buffer = Buffer \ 64
                Mid(EncodedBuffer, Pos - a, 1) = Mid(ConvertionTable64, char, 1)
            Next a
            'AZZERAMENTO E INCREMENTO CONTATORI
            Pos = Pos + 4
            a = 0
        End If
    Loop While i < lenght
    'CONTROLLO RESIDUI DATI
    Select Case a
    Case 0
        'NO DATA TRAPPED: END
        Exit Function
    Case 1
        '1 BYTE TRAPPED
        'PADDING BUFFER
        Buffer = Buffer * 16
        For a = 0 To 1
            'SCRITTURA DATI
            char = Buffer And 63
            char = char + 1
            Buffer = Buffer \ 64
            Mid(EncodedBuffer, Pos - a - 2, 1) = Mid(ConvertionTable64, char, 1)
        Next a
        Mid(EncodedBuffer, Pos - 1, 2) = "=="
    Case Else
        '2 BYTES TRAPPED
        'PADDING BUFFER
        Buffer = Buffer * 4
        For a = 0 To 2
            'SCRITTURA DATI
            char = Buffer And 63
            char = char + 1
            Buffer = Buffer \ 64
            Mid(EncodedBuffer, Pos - a - 1, 1) = Mid(ConvertionTable64, char, 1)
        Next a
        Mid(EncodedBuffer, Pos, 1) = "="
    End Select
    'FINE
End Function

Public Function Base64Decode(ByVal ArmoredText As String, ByRef BinaryBuffer As String) As Long
    Base64Decode = 0
    'DICHIARAZIONI
    Dim i As Long           'posizione all'interno dell'ArmoredText
    Dim a As Long           'contatore interno, vari utilizzi
    Dim Pos As Long         'posizione all'interno del BinaryBuffer
    Dim lenght As Long      'lunghezza dell'ArmoredText
    Dim Valid As Long       'conta dei caratteri validi
    Dim char As Byte        'carattere letto
    Dim Buffer As Long      'buffer per gli shift
    Dim DeconvertionTable64(255) As Byte  'array per la deconversione dei caratteri.
    'INIZIALIZZAZIONE
    'CARICA LA DECONVERTION TABLE (TAROCCATA):
    For i = 0 To 255
        DeconvertionTable64(i) = Not DeconvertionTable64(i)    'TAROCCAGGIO
    Next i
    For i = 48 To 57   'CARATTERI NUMERICI
        DeconvertionTable64(i) = i + 4
    Next i
    For i = 65 To 90   'LETTERE MAIUSCOLE
        DeconvertionTable64(i) = i - 65
    Next i
    For i = 97 To 122  'LETTERE MINUSCOLE
        DeconvertionTable64(i) = i - 71
    Next i
    'SEGNI + E /
    DeconvertionTable64(43) = 62
    DeconvertionTable64(47) = 63
    'DECONVERTION TABLE LOADED
    Valid = 0
    Buffer = 0
    a = 0
    Pos = 1
    i = 1
    lenght = Len(ArmoredText)
    If lenght = 0 Then
        Base64Decode = -6
        Exit Function
    End If
    BinaryBuffer = Space(3 * lenght \ 4)
    'DECODIFICA
    Do
        char = DeconvertionTable64(Asc(Mid(ArmoredText, i, 1)))
        If char > 63 Then
            'CARATTERE ESTRANEO
            GoTo ciclo
        Else
            'CARATTERE VALIDO
            Valid = Valid + 1
            'CARICA IL BUFFER
            Buffer = (Buffer * 64) Or char
            a = a + 1
            If a = 4 Then
                'BUFFER FULL
                For a = 0 To 2
                    'DECODIFICA
                    char = Buffer And 255 'LEGGE UN BYTE
                    Buffer = Buffer \ 256 'SHIFTA IL BUFFER
                    Mid(BinaryBuffer, Pos + 2 - a, 1) = Chr(char) 'SCRIVE IL BYTE
                Next a
                'BUFFER SVUOTATO
                Pos = Pos + 3
                a = 0
            End If
        End If
ciclo:
        i = i + 1
    Loop Until i > lenght
    'CONTROLLO ERRORI
    If (Valid And 3) = 1 Then
        Base64Decode = -1
        Return
    End If
    'CONTROLLO RESIDUI DATI
    Valid = Valid * 3 \ 4 'DIMENSIONE TEORICA
    a = Valid - Pos + 1 'NUMERO DI BYTES RESIDUI
    If a > 0 Then
        'DATI INTRAPPOLATI NEL BUFFER: <a> BYTES (DA 1 A 3)
        'ELIMINAZIONE BIT DI PADDING DAL FONDO DEL BUFFER
        If a = 1 Then
            Buffer = Buffer \ 16
        Else
            Buffer = Buffer \ 4
        End If
        'DECODIFICA RESIDUI DATI
        For i = 1 To a
            char = Buffer And 255 'LEGGE UN BYTE
            Mid(BinaryBuffer, Pos + a - i, 1) = Chr(char) 'SCRIVE IL BYTE
            Buffer = Buffer \ 256 'SHIFTA IL BUFFER
        Next i
    End If
    'RIDIMENSIONAMENTO SPAZIO ALLOCATO E FINE
    BinaryBuffer = Left(BinaryBuffer, Valid)
End Function
